#include "StdAfx.h"
#include "saMP.h"

/* ------------------------ */
/* AudioConfig::AudioConfig */
/* ------------------------ */
AudioConfig::AudioConfig() : 
	m_Volume(100.f),
	m_Repeat(false),
	m_Random(false)
{
}

/* --------------------- */
/* AudioConfig::VolumeUp */
/* --------------------- */
void AudioConfig::VolumeUp()
{
	m_Volume += VOLUME_STEP;
	if (m_Volume > 100.f)
	{
		m_Volume = 100.f;
	}
	Notify();
}

/* ----------------------- */
/* AudioConfig::VolumeDown */
/* ----------------------- */
void AudioConfig::VolumeDown()
{
	m_Volume -= VOLUME_STEP;
	if (m_Volume < 0.f)
	{
		m_Volume = 0.f;
	}
	Notify();
}

/* ---------------------- */
/* AudioConfig::GetVolume */
/* ---------------------- */
float AudioConfig::GetVolume() const
{
	return m_Volume;
}

/* ------------------- */
/* AudioConfig::Repeat */
/* ------------------- */
void AudioConfig::Repeat()
{
	m_Repeat = !m_Repeat;
}

/* ---------------------- */
/* AudioConfig::GetRepeat */
/* ---------------------- */
bool AudioConfig::GetRepeat() const
{
	return m_Repeat;
}

/* ------------------- */
/* AudioConfig::Random */
/* ------------------- */
void AudioConfig::Random()
{
	m_Random = !m_Random;
}

/* ---------------------- */
/* AudioConfig::GetRandom */
/* ---------------------- */
bool AudioConfig::GetRandom() const
{
	return m_Random;
}
