#pragma once

const float VOLUME_STEP = 10.f;

/**
* Class AudioConfig
* This class manages the general audio configuration (volume, playing mode... ). 
* @author Adrian Gaudebert - adrian.gaudebert@gmail.com
* @author Simon Stephan - s.stephan88@gmail.com
*/
class AudioConfig : public Singleton<AudioConfig>, public Subject
{
 
	friend class Singleton<AudioConfig>;

private:	//--> Attributs privs

	float m_Volume;

	bool m_Repeat;

	bool m_Random;

private:	//--> Mthodes prives

	AudioConfig();

public:		//--> Mthodes publiques

	/**
	* Put the current volume up
	*/
	void VolumeUp();

	/**
	* Put the current volume down
	*/
	void VolumeDown();

	/**
	* Get the current volume
	* @return Float between 0 and 100
	*/
	float GetVolume() const;

	/**
	* Reverse the current repeat mode
	*/
	void Repeat();

	/**
	* Get the current repeat mode
	*/
	bool GetRepeat() const;

	/**
	* Reverse the current random mode
	*/
	void Random();

	/**
	* Get the current random mode
	*/
	bool GetRandom() const;

};
