#include "StdAfx.h"
#include "saMP.h"

/* ------------ */
/* Music::Music */
/* ------------ */
Music::Music() : 
	m_FileName("")
{
}

/* ----------- */
/* Music::Load */
/* ----------- */
bool Music::Load(const CString& _FileName)
{
	char *chFileName = new char[_FileName.GetLength() + 1];
	for (int i = 0; i < _FileName.GetLength(); i++)
	{
		chFileName[i] = static_cast<char>( _FileName[i] );
	}
	chFileName[_FileName.GetLength()] = '\0';

	return Load(chFileName);
}

/* ----------- */
/* Music::Load */
/* ----------- */
bool Music::Load(const char* _FileName)
{
	if ( m_Music.OpenFromFile(_FileName) )
	{
		m_FileName = _FileName;
		return true;
	}
	return false;
}

/* ----------- */
/* Music::Play */
/* ----------- */
void Music::Play()
{
	if ( Playing() )
	{
		m_Music.Pause();
		m_Timer.Pause();
	}
	else
	{
		m_Music.Play();
		m_Timer.Start();
	}
}

/* ----------- */
/* Music::Stop */
/* ----------- */
void Music::Stop()
{
	m_Music.Stop();
	m_Timer.Reset();
}

/* -------------- */
/* Music::Stopped */
/* -------------- */
bool Music::Stopped() const
{
	return ( m_Music.GetStatus() == sf::Sound::Stopped );
}

/* ------------- */
/* Music::Paused */
/* ------------- */
bool Music::Paused() const
{
	return ( m_Music.GetStatus() == sf::Sound::Paused );
}

/* -------------- */
/* Music::Playing */
/* -------------- */
bool Music::Playing() const
{
	return ( m_Music.GetStatus() == sf::Sound::Playing );
}

/* ------------ */
/* Music::Ended */
/* ------------ */
bool Music::Ended()
{
	if ( m_Timer.GetElapsedTime() >= m_Music.GetDuration() )
	{
		return true;
	}
	return false;
}

/* ------------------ */
/* Music::GetFileName */
/* ------------------ */
const CString& Music::GetFileName() const
{
	return m_FileName;
}

/* ---------------- */
/* Music::SetVolume */
/* ---------------- */
void Music::SetVolume(float _Volume)
{
	m_Music.SetVolume(_Volume);
}
