#pragma once

/**
* Class Observer
* Implementation of the observer pattern.
* @author Adrian Gaudebert - adrian.gaudebert@gmail.com
* @author Simon Stephan - s.stephan88@gmail.com
*/
class Observer
{

private:
	
	CList<Subject*, Subject*> m_SubjectList;

public:

	/**
	* Destructor
	*/
	virtual ~Observer(void);
	
	/**
	* Add a subject to this observer
	* @param _Sub Pointer to the subject
	*/
	void AddSubject(Subject* _Sub);

	/**
	* Delete a subject from the list
	* @param _Sub Pointer to the subject
	*/
	void DeleteSubject(Subject* _Sub);

	/**
	* Virtual method to be implemented in the children classes
	*/
	virtual void Update();

};
