// PlayListManagDlg.cpp: fichier d'implmentation
//

#include "stdafx.h"
#include "saMP.h"
#include "PlayListManagDlg.h"


// Bote de dialogue CPlayListManagDlg

IMPLEMENT_DYNAMIC(CPlayListManagDlg, CDialog)

CPlayListManagDlg::CPlayListManagDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPlayListManagDlg::IDD, pParent)
	, m_pMusicList(NULL)
{

}

CPlayListManagDlg::~CPlayListManagDlg()
{
}

void CPlayListManagDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST1, m_ListBox);
}


BEGIN_MESSAGE_MAP(CPlayListManagDlg, CDialog)
	ON_BN_CLICKED(IDC_BUTTON_DELETE, &CPlayListManagDlg::OnBnClickedButtonDelete)
	ON_LBN_DBLCLK(IDC_LIST1, &CPlayListManagDlg::OnLbnDblclkList1)
	ON_BN_CLICKED(IDC_BUTTON_SAVE, &CPlayListManagDlg::OnBnClickedButtonSave)
	ON_BN_CLICKED(IDC_BUTTON_LOAD, &CPlayListManagDlg::OnBnClickedButtonLoad)
//	ON_BN_DOUBLECLICKED(IDC_BUTTON_UP, &CPlayListManagDlg::OnBnDoubleclickedButtonUp)
ON_BN_CLICKED(IDC_BUTTON_UP, &CPlayListManagDlg::OnBnClickedButtonUp)
ON_BN_CLICKED(IDC_BUTTON_DOWN, &CPlayListManagDlg::OnBnClickedButtonDown)
ON_BN_CLICKED(IDC_BUTTON_CLEAR, &CPlayListManagDlg::OnBnClickedButtonClear)
END_MESSAGE_MAP()


// Gestionnaires de messages de CPlayListManagDlg

BOOL CPlayListManagDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO:  Ajoutez ici une initialisation supplmentaire
	if (m_pMusicList == NULL)
	{
		MessageBox( (CString) "Error - No play list given" );
	}
	else
	{
		DisplayList();
	}

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: les pages de proprits OCX devraient retourner FALSE
}

/* ------------------------------ */
/* CPlayListManagDlg::DisplayList */
/* ------------------------------ */
void CPlayListManagDlg::DisplayList()
{
	// Nettoyage de la liste
	m_ListBox.ResetContent();

	// Affichage de la liste des musiques
	POSITION it = m_pMusicList->GetHeadPosition();

	if (it != NULL)
	{
		m_ListBox.AddString( m_pMusicList->GetAt(it)->GetFileName() );

		while (it != m_pMusicList->GetTailPosition() )
		{
			m_pMusicList->GetNext(it);
			m_ListBox.AddString( m_pMusicList->GetAt(it)->GetFileName() );
		}
	}
}

/* ------------------------------------- */
/* CPlayListManagDlg::GetCurrentPosition */
/* ------------------------------------- */
POSITION CPlayListManagDlg::GetCurrentPosition()
{
	int Index = m_ListBox.GetCurSel();
	POSITION it = m_pMusicList->GetHeadPosition();

	if ( ( it != NULL ) && ( Index != LB_ERR ) )
	{
		for (int i = 0; i < Index; i++)
		{
			m_pMusicList->GetNext(it);
		}

		return it;
	}

	return NULL;
}

/* ------------------------------ */
/* CPlayListManagDlg::SetPlayList */
/* ------------------------------ */
void CPlayListManagDlg::SetPlayList(PlayList &_PlayList)
{
	m_pPlayList = &_PlayList;
	m_pMusicList = &( _PlayList.GetMusicList() );
}

/* ---------------------------- */
/* CPlayListManagDlg::SetParent */
/* ---------------------------- */
void CPlayListManagDlg::SetParent(CsaMPDlg *_Parent)
{
	m_Parent = _Parent;
}

/* ------------------------------------------ */
/* CPlayListManagDlg::OnBnClickedButtonDelete */
/* ------------------------------------------ */
void CPlayListManagDlg::OnBnClickedButtonDelete()
{
	POSITION it = GetCurrentPosition();
	if ( it != NULL )
	{
		CSingleLock Lock( &( m_pPlayList->AccessMusicList ) );
		Lock.Lock();

		m_pPlayList->RemoveAt(it);

		Lock.Unlock();

		DisplayList();
	}
}

/* ----------------------------------- */
/* CPlayListManagDlg::OnLbnDblclkList1 */
/* ----------------------------------- */
void CPlayListManagDlg::OnLbnDblclkList1()
{
	POSITION it = GetCurrentPosition();
	if ( it != NULL )
	{
		m_pPlayList->PlayAt(it);
	}
}

/* ---------------------------------------- */
/* CPlayListManagDlg::OnBnClickedButtonSave */
/* ---------------------------------------- */
void CPlayListManagDlg::OnBnClickedButtonSave()
{
	if (m_Parent != NULL)
	{
		m_Parent->SavePlayList();
	}
}

/* ---------------------------------------- */
/* CPlayListManagDlg::OnBnClickedButtonLoad */
/* ---------------------------------------- */
void CPlayListManagDlg::OnBnClickedButtonLoad()
{
	if (m_Parent != NULL)
	{
		m_Parent->LoadPlayList();

		DisplayList();
	}
}

/* -------------------------------------- */
/* CPlayListManagDlg::OnBnClickedButtonUp */
/* -------------------------------------- */
void CPlayListManagDlg::OnBnClickedButtonUp()
{
	POSITION it = GetCurrentPosition();
	if ( ( it != NULL ) && ( it != m_pMusicList->GetHeadPosition() ) )
	{
		CSingleLock Lock( &( m_pPlayList->AccessMusicList ) );
		Lock.Lock();

		POSITION toDelete = it;
		Music *pMusic = m_pMusicList->GetPrev(it);
		m_pMusicList->InsertBefore(it, pMusic);
		m_pMusicList->RemoveAt(toDelete);

		Lock.Unlock();
		
		m_pMusicList->GetPrev(it);
		m_pPlayList->SetCurrentPosition(it);

		DisplayList();
	}
}

/* ---------------------------------------- */
/* CPlayListManagDlg::OnBnClickedButtonDown */
/* ---------------------------------------- */
void CPlayListManagDlg::OnBnClickedButtonDown()
{
	POSITION it = GetCurrentPosition();
	if ( ( it != NULL ) && ( it != m_pMusicList->GetTailPosition() ) )
	{
		CSingleLock Lock( &( m_pPlayList->AccessMusicList ) );
		Lock.Lock();

		POSITION toDelete = it;
		Music *pMusic = m_pMusicList->GetNext(it);
		m_pMusicList->InsertAfter(it, pMusic);
		m_pMusicList->RemoveAt(toDelete);

		Lock.Unlock();

		m_pMusicList->GetNext(it);
		m_pPlayList->SetCurrentPosition(it);

		DisplayList();
	}
}

/* ----------------------------------------- */
/* CPlayListManagDlg::OnBnClickedButtonClear */
/* ----------------------------------------- */
void CPlayListManagDlg::OnBnClickedButtonClear()
{
	CSingleLock Lock( &( m_pPlayList->AccessMusicList ) );
	Lock.Lock();

	m_pPlayList->ClearList();

	Lock.Unlock();

	DisplayList();
}
