#pragma once

#ifndef NULL
	#define NULL 0
#endif

/**
* Class Singleton
* Generic class for design pattern Singleton.
* @author Adrian Gaudebert - adrian.gaudebert@gmail.com
* @author Simon Stephan - s.stephan88@gmail.com
*/
template <typename T>
class Singleton
{
private:	//--> Attributs privs

	static T* m_pInstance;

private:	//--> Mthodes prives

	/**
	* Constructor by copy
	*/
	Singleton(const Singleton<T>&) {}

	/**
	* Assignment operator
	*/
	void operator =(const Singleton&) {}

protected:	//--> Mthodes protges

	/**
	* Default constructor
	*/
	Singleton() {}

	/**
	* Destructor
	*/
	virtual ~Singleton() {}

public:		//--> Mthodes publiques

	/**
	* Create the instance
	*/
	static void Create()
	{
		if(m_pInstance == NULL)
		{
			m_pInstance = new T();
		}
	}

	/**
	* Delete the instance
	*/
	static void Release()
	{
		if(m_pInstance != NULL)
		{
			delete m_pInstance;
			m_pInstance = NULL;
		}
	}

	/**
	* Return a reference to the instance
	*/
	static T& Get()
	{
		Create();
		return *m_pInstance;
	}

};

template <typename T> T *Singleton<T>::m_pInstance = NULL;
