#include "StdAfx.h"
#include "saMP.h"

/* ----------------- */
/* Subject::~Subject */
/* ----------------- */
Subject::~Subject()
{
	POSITION it = m_ObserverList.GetHeadPosition();

	if (it != NULL)
	{
		m_ObserverList.GetAt(it)->DeleteSubject(this);

		while (it != m_ObserverList.GetTailPosition() )
		{
			m_ObserverList.GetNext(it);
			m_ObserverList.GetAt(it)->DeleteSubject(this);
		}
	}
}

/* --------------- */
/* Subject::Notify */
/* --------------- */
void Subject::Notify()
{
	POSITION it = m_ObserverList.GetHeadPosition();

	if (it != NULL)
	{
		m_ObserverList.GetAt(it)->Update();

		while (it != m_ObserverList.GetTailPosition() )
		{
			m_ObserverList.GetNext(it);
			m_ObserverList.GetAt(it)->Update();
		}
	}
}

/* -------------------- */
/* Subject::AddObserver */
/* -------------------- */
void Subject::AddObserver(Observer* _Obs)
{
	m_ObserverList.AddTail(_Obs);

	_Obs->AddSubject(this);
}

/* ----------------------- */
/* Subject::DeleteObserver */
/* ----------------------- */
void Subject::DeleteObserver(Observer* _Obs)
{
	m_ObserverList.RemoveAt( m_ObserverList.Find(_Obs) );
}
