#pragma once

class Observer;

/**
* Class Subject
* Implementation of the observer pattern.
* @author Adrian Gaudebert - adrian.gaudebert@gmail.com
* @author Simon Stephan - s.stephan88@gmail.com
*/
class Subject
{

private:

	CList<Observer*, Observer*> m_ObserverList;

protected:

	/**
	* Notify to the subscribed observers that a change has happened
	*/
	void Notify();

public:

	/**
	* Destructor
	*/
	virtual ~Subject();

	/**
	* Add an observer
	* @param _Obs Pointer to the observer
	*/
	void AddObserver(Observer* _Obs);

	/**
	* Remove an observer
	* @param _Obs Pointer to the observer
	*/
	void DeleteObserver(Observer* _Obs);

};
