// saMPDlg.h : fichier d'en-tte
//

#pragma once
#include "afxwin.h"

enum Action
{
	None,
	Play,
	Stop,
	Next,
	Previous,
	Repeat,
	Random,
	VolumeUp,
	VolumeDown,
	AddMusic,
	Load,
	Save,
	EditPlayList
};


// bote de dialogue CsaMPDlg
class CsaMPDlg : public CDialog
{
private:
	Action m_CurrentAction;
	CMap<Action, Action, CRect, CRect> m_BtnList;
	PlayList m_PlayList;

// Construction
public:
	CsaMPDlg(CWnd* pParent = NULL);	// constructeur standard

// Donnes de bote de dialogue
	enum { IDD = IDD_SAMP_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// Prise en charge de DDX/DDV


// Implmentation
protected:
	HICON m_hIcon;

	// Fonctions gnres de la table des messages
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);

private:
	void InitButtonRect();
	void TestMousePosition(const CPoint& _Point);
	void LaunchAction();
	void PlayMusic();
	void StopMusic();
	void LoadMusic();
	CString LoadFileDialog(bool _OpenMode, bool _LoadMusic = true);
	void LaunchPlayListManager();

public:
	void SavePlayList();
	void LoadPlayList();

public:
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnTimer(UINT_PTR nIDEvent);
};
